//---------------------------------------------------------------------------
#include "DSTP2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TWebModule1 *WebModule1;
//---------------------------------------------------------------------------
__fastcall TWebModule1::TWebModule1(TComponent* Owner)
	: TWebModule(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TWebModule1::WebModule1initialAction(TObject *Sender,
      TWebRequest *Request, TWebResponse *Response, bool &Handled)
{
Response->Content = DataSetTableProducer1->Content();
}
//---------------------------------------------------------------------------

void __fastcall TWebModule1::WebModule1defaultAction(TObject *Sender,
      TWebRequest *Request, TWebResponse *Response, bool &Handled)
{
Response->Content = "<H2>  !</H2>";
}
//---------------------------------------------------------------------------

void __fastcall TWebModule1::DataSetTableProducer1FormatCell(
      TObject *Sender, int CellRow, int CellColumn, THTMLBgColor &BgColor,
      THTMLAlign &Align, THTMLVAlign &VAlign, AnsiString &CustomAttrs,
      AnsiString &CellData)
{
  if ((CellRow>0) && (CellColumn==0))
    CellData = "<a href=dstp_p2.exe\\full?EventNo="+
                Table1->Fields->Fields[0]->AsString +">"+ CellData + "</A>";
}
//---------------------------------------------------------------------------

void __fastcall TWebModule1::WebModule1fullAction(TObject *Sender,
      TWebRequest *Request, TWebResponse *Response, bool &Handled)
{
AnsiString q1;
TLocateOptions options;
  q1 = Request->QueryFields->Values["EventNo"];
  Table1->Locate("EventNo", q1, options);
  Response->Content =DataSetPageProducer1->Content();
}
//---------------------------------------------------------------------------

void __fastcall TWebModule1::DataSetPageProducer1HTMLTag(TObject *Sender,
      TTag Tag, const AnsiString TagString, TStrings *TagParams,
      AnsiString &ReplaceText)
{
  if (CompareText(TagString, "Event_Photo") == 0)
    ReplaceText = "<img src=Photo?EventNo="+Table1->Fields->Fields[0]->AsString+">";
  if (CompareText(TagString, "Event_Description") == 0)
    ReplaceText = Table1->FieldByName("Event_Description")->AsString;
}
//---------------------------------------------------------------------------

void __fastcall TWebModule1::WebModule1PhotoAction(TObject *Sender,
      TWebRequest *Request, TWebResponse *Response, bool &Handled)
{
Graphics::TBitmap *B = new Graphics::TBitmap();
TMemoryStream *S = new TMemoryStream();
AnsiString q1;
TLocateOptions options;

  q1 = Request->QueryFields->Values["EventNo"];
  Table1->Locate("EventNo", q1, options);
  B->Assign(Table1->FieldByName("Event_Photo"));
  B->SaveToStream(S);
  S->Position =0;
  Response->ContentType   = "image/x-xbitmap";
  Response->ContentStream = S;
  B->Free();
}
//---------------------------------------------------------------------------

