// FIRSTASP2IMPL : Implementation of TFirstASP2Impl

#include <vcl.h>
#pragma hdrstop

#include "FIRSTASP2IMPL.H"

/////////////////////////////////////////////////////////////////////////////
// TFirstASP2Impl
STDMETHODIMP TFirstASP2Impl::OnEndPage()
{
  HRESULT hr = E_FAIL;
  try
  {
    hr = TASPObject::OnEndPage();
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IFirstASP2);
  }

  return hr;
}


STDMETHODIMP TFirstASP2Impl::OnStartPage(LPUNKNOWN AScriptingContext)
{
  HRESULT hr = E_FAIL;
  try
  {
    hr = TASPObject::OnStartPage(AScriptingContext);
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IFirstASP2);
  }

  return hr;
}



STDMETHODIMP TFirstASP2Impl::GetTime(BSTR* Param1)
{
  *Param1 = WideString( TimeToStr(Time())).Copy();
  return 1;
}

