//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ftp_dem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  ShowMessage(" ,   \"\"");
  NMFTP1->Reinitialize();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
AnsiString  AnID, APass;
  if (InputQuery("", "  ", AnID))
    if (InputQuery("", " ", APass)) {
        NMFTP1->DoCommand("USER "+AnID);
        NMFTP1->DoCommand("PASS "+APass);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if (!NMFTP1->Connected) {
      NMFTP1->Vendor = NMOS_AUTO;
      NMFTP1->TimeOut = 5000;
      NMFTP1->Host = Edit1->Text;
      NMFTP1->UserID = Edit2->Text;
      NMFTP1->Password = Edit3->Text;
      NMFTP1->Connect();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if (NMFTP1->Connected)
    NMFTP1->Disconnect();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  NMFTP1->List();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button16Click(TObject *Sender)
{
AnsiString  TheDir;
  if (InputQuery(" ", "  ", TheDir))
    NMFTP1->ChangeDir(TheDir);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
AnsiString  TheDir;
  if (InputQuery(" ", "  ", TheDir))
    NMFTP1->MakeDirectory(TheDir);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
AnsiString  TheDir;
  if (InputQuery(" ", "  ", TheDir))
    NMFTP1->RemoveDir(TheDir);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button17Click(TObject *Sender)
{
  ShowMessage(NMFTP1->CurrentDir);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
AnsiString  OldFile, NewFile;
  if (InputQuery(" ", "  ", OldFile))
    if (InputQuery(" ", "  ", NewFile))
      NMFTP1->Rename(OldFile, NewFile);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
AnsiString  TheFile;
  if (InputQuery(" ", "  ", TheFile))
    NMFTP1->Delete(TheFile);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
AnsiString  RemoteFile, LocalFile;
  if (InputQuery(" ", " : ", RemoteFile))
      if (OpenDialog1->Execute()) {
        LocalFile = OpenDialog1->FileName;
        switch (RadioGroup1->ItemIndex) {
          case  0: NMFTP1->Mode(MODE_ASCII); break;
          case  1: NMFTP1->Mode(MODE_IMAGE); break;
          case  2: NMFTP1->Mode(MODE_BYTE);  break;
        }
        NMFTP1->Download(RemoteFile, LocalFile);
      }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
AnsiString  RemoteFile, LocalFile;
  if (InputQuery("  ", " : ", RemoteFile))
      if (OpenDialog1->Execute()) {
        LocalFile = OpenDialog1->FileName;
        switch (RadioGroup1->ItemIndex) {
          case  0: NMFTP1->Mode(MODE_ASCII); break;
          case  1: NMFTP1->Mode(MODE_IMAGE); break;
          case  2: NMFTP1->Mode(MODE_BYTE);  break;
        }
        NMFTP1->DownloadRestore(RemoteFile, LocalFile);
      }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
AnsiString  LocalFile, RemoteFile;
int FSize, FH1;
    if (OpenDialog1->Execute())
      if (InputQuery("   ", "    ", RemoteFile)) {
          LocalFile = OpenDialog1->FileName;
          switch (RadioGroup1->ItemIndex) {
            case 0: NMFTP1->Mode(MODE_ASCII); break;
            case 1: NMFTP1->Mode(MODE_IMAGE); break;
            case 2: NMFTP1->Mode(MODE_BYTE);  break;
          }
          FH1 = FileOpen(LocalFile, fmOpenRead);
          FSize = FileSeek(FH1, 0, 2);
          FileClose(FH1);
          NMFTP1->Allocate(FSize);
          NMFTP1->Upload(LocalFile, RemoteFile);
      }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
AnsiString  LocalFile, RemoteFile, FPos;
int  FPosition;
    if (OpenDialog1->Execute())
      if (InputQuery("    ", "    ", RemoteFile))
        if (InputQuery("  ", "    : ", FPos)) {
            FPosition = StrToInt(FPos);
            LocalFile = OpenDialog1->FileName;
            switch (RadioGroup1->ItemIndex) {
              case 0: NMFTP1->Mode(MODE_ASCII); break;
              case 1: NMFTP1->Mode(MODE_IMAGE); break;
              case 2: NMFTP1->Mode(MODE_BYTE); break;
            }
            NMFTP1->UploadRestore(LocalFile, RemoteFile, FPosition);
        }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
AnsiString  LocalFile, RemoteFile;
    if (OpenDialog1->Execute())
      if (InputQuery("     ", "    ", RemoteFile)) {
          LocalFile = OpenDialog1->FileName;
          switch (RadioGroup1->ItemIndex) {
            case 0: NMFTP1->Mode(MODE_ASCII); break;
            case 1: NMFTP1->Mode(MODE_IMAGE); break;
            case 2: NMFTP1->Mode(MODE_BYTE); break;
          }
          NMFTP1->UploadAppend(LocalFile, RemoteFile);
      }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)
{
AnsiString  LocalFile;
    if (OpenDialog1->Execute()) {
          LocalFile = OpenDialog1->FileName;
          switch (RadioGroup1->ItemIndex) {
            case 0: NMFTP1->Mode(MODE_ASCII); break;
            case 1: NMFTP1->Mode(MODE_IMAGE); break;
            case 2: NMFTP1->Mode(MODE_BYTE); break;
          }
          NMFTP1->UploadUnique(LocalFile);
    }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1AuthenticationFailed(bool &Handled)
{
AnsiString  ThePass, TheID;
  if (MessageDlg(" .  ?", mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
      ThePass = NMFTP1->Password;
      TheID = NMFTP1->UserID;
      InputQuery(" ", "  ", TheID);
      InputQuery(" ", " ", ThePass);
      NMFTP1->Password = ThePass;
      NMFTP1->UserID = TheID;
      Handled = true;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1AuthenticationNeeded(bool &Handled)
{
AnsiString  APass, AnID;
  if (NMFTP1->Password == "")
      if (InputQuery(" ", " : ", APass)) {
          NMFTP1->Password = APass;
          Handled = true;
      }
      else
        Handled = false;

  if (NMFTP1->UserID == "")
      if (InputQuery("  ", "  : ", AnID)) {
          NMFTP1->UserID = AnID;
          Handled = true;
      }
      else
        Handled = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1Connect(TObject *Sender)
{
  Memo1->Lines->Add("...");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1Disconnect(TObject *Sender)
{
  Memo1->Lines->Add(" ...");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1Failure(bool &Handled, TCmdType Trans_Type)
{
  switch (Trans_Type) {
    case cmdChangeDir: Memo1->Lines->Add("  "); break;
    case cmdMakeDir: Memo1->Lines->Add("  "); break;
    case cmdDelete: Memo1->Lines->Add("  "); break;
    case cmdRemoveDir: Memo1->Lines->Add("  "); break;
    case cmdList: Memo1->Lines->Add("  "); break;
    case cmdRename: Memo1->Lines->Add("  "); break;
    case cmdUpRestore: Memo1->Lines->Add("  UploadRestore"); break;
    case cmdDownRestore: Memo1->Lines->Add("  DownloadRestore"); break;
    case cmdDownload: Memo1->Lines->Add("  Download"); break;
    case cmdUpload: Memo1->Lines->Add("  Upload"); break;
    case cmdAppend: Memo1->Lines->Add("  UploadAppend"); break;
    case cmdReInit: Memo1->Lines->Add("  Reinitialize"); break;
    case cmdAllocate: Memo1->Lines->Add("  Allocate"); break;
    case cmdNList: Memo1->Lines->Add("  NList"); break;
    case cmdDoCommand: Memo1->Lines->Add("  DoCommand"); break;
    case cmdCurrentDir: Memo1->Lines->Add("  CurrentDir"); break;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1PacketRecvd(TObject *Sender)
{
  StatusBar1->SimpleText = " "+IntToStr(NMFTP1->BytesRecvd)+"   "+IntToStr(NMFTP1->BytesTotal);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1PacketSent(TObject *Sender)
{
  StatusBar1->SimpleText = " "+IntToStr(NMFTP1->BytesSent)+"   "+IntToStr(NMFTP1->BytesTotal);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1Success(TCmdType Trans_Type)
{
int I;
  switch (Trans_Type) {
    case cmdList:
      {
        for (I = 0; I < StringGrid1->ColCount; I++)
          StringGrid1->Cols[I]->Clear();
        StringGrid1->RowCount = NMFTP1->FTPDirectoryList->name->Count;
        StringGrid1->ColCount = 4;
        StringGrid1->Cells[0][0] = " ";
        StringGrid1->Cells[1][0] = " ";
        StringGrid1->Cells[2][0] = " ";
        StringGrid1->Cells[3][0] = "";
        for (I = 0; I < NMFTP1->FTPDirectoryList->name->Count; I++) {
              StringGrid1->Cells[0][I+1] = NMFTP1->FTPDirectoryList->name->Strings[I];
              StringGrid1->Cells[1][I+1] = NMFTP1->FTPDirectoryList->Size->Strings[I];
              StringGrid1->Cells[2][I+1] = NMFTP1->FTPDirectoryList->ModifDate->Strings[I];
              StringGrid1->Cells[3][I+1] = NMFTP1->FTPDirectoryList->Attribute->Strings[I];
        }
        Memo1->Lines->Add("   - ");
      }
    case cmdChangeDir:
      {
        Memo1->Lines->Add("  - ");
        NMFTP1->List();
      }
    case cmdMakeDir:    Memo1->Lines->Add("  - "); break;
    case cmdRemoveDir:  Memo1->Lines->Add("  - "); break;
    case cmdDelete:     Memo1->Lines->Add("  - ");  break;
    case cmdRename:     Memo1->Lines->Add("  - "); break;
    case cmdReInit:     Memo1->Lines->Add(" - ");  break;
    case cmdCurrentDir: Memo1->Lines->Add("   - "); break;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1TransactionStart(TObject *Sender)
{
  Memo1->Lines->Add("  ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1TransactionStop(TObject *Sender)
{
  Memo1->Lines->Add("  .");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMFTP1UnSupportedFunction(TCmdType Trans_Type)
{
 switch (Trans_Type) {
    case cmdChangeDir: Memo1->Lines->Add(" ChangeDir    "); break;
    case cmdMakeDir: Memo1->Lines->Add(" MakeDir    "); break;
    case cmdDelete: Memo1->Lines->Add(" Delete    "); break;
    case cmdRemoveDir: Memo1->Lines->Add(" RemoveDir    "); break;
    case cmdList: Memo1->Lines->Add(" List    "); break;
    case cmdRename: Memo1->Lines->Add(" Rename    "); break;
    case cmdUpRestore: Memo1->Lines->Add(" UploadRestore    "); break;
    case cmdDownRestore: Memo1->Lines->Add(" DownloadRestore    "); break;
    case cmdDownload: Memo1->Lines->Add(" Download    "); break;
    case cmdUpload: Memo1->Lines->Add(" Upload    "); break;
    case cmdAppend: Memo1->Lines->Add(" UploadAppend    "); break;
    case cmdReInit: Memo1->Lines->Add(" Reinitialize    "); break;
    case cmdAllocate: Memo1->Lines->Add(" Allocate    "); break;
    case cmdNList: Memo1->Lines->Add(" NList    "); break;
    case cmdDoCommand: Memo1->Lines->Add(" DoCommand    "); break;
    case cmdCurrentDir: Memo1->Lines->Add(" CurrentDir    "); break;
  }

}
//---------------------------------------------------------------------------


