//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "nntp_dem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
Label7->Caption = "    : "+ NMNNTP1->AttachFilePath;
if (NMNNTP1->ParseAttachments == true)
  CheckBox1->Checked = true;
else
  CheckBox1->Checked = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  if (CheckBox1->Checked)
    NMNNTP1->ParseAttachments = true;
  else
    NMNNTP1->ParseAttachments = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ListBox1Click(TObject *Sender)
{
  if (ListBox1->ItemIndex != -1) {
      ListBox2->Clear();
      NMNNTP1->SetGroup(ListBox1->Items->Strings[ListBox1->ItemIndex]);
      Label3->Caption  = "   "+NMNNTP1->SelectedGroup;
      Label14->Caption = "     : "+NMNNTP1->SelectedGroup;
  }
  if (NMNNTP1->Posting)
    Label16->Caption = "     ";
  else
    Label16->Caption = "     ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  ListBox1->Clear();
  ListBox2->Clear();
  if (NMNNTP1->Connected)
     NMNNTP1->Disconnect();
  else {
    if (Edit5->Text != "") {
      NMNNTP1->UserId = Edit5->Text;
      NMNNTP1->Password = Edit6->Text;
    }
    NMNNTP1->Host = Edit1->Text;
    NMNNTP1->Connect();
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
AnsiString S;
int I;
  if (InputQuery(" ", "  ", S)) {
      I = StrToIntDef(S, -1);
      if (I != -1)
        NMNNTP1->GetArticle(I);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
AnsiString S;
int I;
  if (InputQuery("  ", "  ", S)) {
    I = StrToIntDef(S, -1);
    if (I != -1)
      NMNNTP1->GetArticleHeader(I);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
AnsiString S;
int I;
  if (InputQuery("  ", "  ", S)) {
      I = StrToIntDef(S, -1);
      if (I != -1)
        NMNNTP1->GetArticleBody(I);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
AnsiString S;
 if (SelectDirectory(S, TSelectDirOpts() << sdAllowCreate << sdPerformCreate << sdPrompt, 0)) {
    Label7->Caption = "    : "+ S;
    NMNNTP1->AttachFilePath = S;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  NMNNTP1->GetArticleList(true, 0);
  Caption = "   "+NMNNTP1->SelectedGroup+"   "+IntToStr(NMNNTP1->LoMessage)+"   "+IntToStr(NMNNTP1->HiMessage);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
  NMNNTP1->Abort();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  if (OpenDialog1->Execute())
    ListBox3->Items->Add(OpenDialog1->FileName);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
  NMNNTP1->PostAttachments->Text = ListBox3->Items->Text;
  NMNNTP1->PostBody->Text = Memo4->Text;
  NMNNTP1->PostRecord->PrFromAddress = Edit7->Text;
  NMNNTP1->PostRecord->PrReplyTo = Edit7->Text;
  NMNNTP1->PostRecord->PrSubject = Edit8->Text;
  NMNNTP1->PostRecord->PrNewsGroups = NMNNTP1->SelectedGroup;
  NMNNTP1->PostHeader->Values["Organization"] = "  ++Builder";
  NMNNTP1->PostArticle();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Abort(TObject *Sender)
{
 StatusBar1->SimpleText = "  ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Article(TObject *Sender)
{
  Memo2->Text = NMNNTP1->Body->Text;
  Memo1->Text = NMNNTP1->Header->Text;
  Memo3->Text = NMNNTP1->Attachments->Text;
  Edit2->Text = NMNNTP1->HeaderRecord->PrFromAddress;
  Edit3->Text = NMNNTP1->HeaderRecord->PrSubject;
  Edit4->Text = NMNNTP1->HeaderRecord->PrTimeDate;
  Label5->Caption = "    "+IntToStr(NMNNTP1->CurrentArticle);
  Label6->Caption = "   "+IntToStr(NMNNTP1->CurrentArticle);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1AuthenticationFailed(TObject *Sender)
{
  ShowMessage(" ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1AuthenticationNeeded(bool &Handled)
{
AnsiString AnID, APass;
  if (NMNNTP1->UserId == "")
      if (InputQuery(" ", "  ", AnID)) {
          NMNNTP1->UserId = AnID;
          Handled = true;
      }
  if (NMNNTP1->Password == "")
      if (InputQuery(" ", " ", APass)) {
          NMNNTP1->Password = APass;
          Handled = true;
      }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Body(TObject *Sender)
{
  Memo2->Text = NMNNTP1->Body->Text;
  Memo3->Text = NMNNTP1->Attachments->Text;
  Label6->Caption = "   "+IntToStr(NMNNTP1->CurrentArticle);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Connect(TObject *Sender)
{
int I;
  StatusBar1->SimpleText = "";
  ShowMessage("    . ");
  NMNNTP1->GetGroupList();
  for (I = 0; I < NMNNTP1->GroupList->Count; I++)
    ListBox1->Items->Add(NthWord(NMNNTP1->GroupList->Strings[I], ' ', 1));
}

//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Disconnect(TObject *Sender)
{
  StatusBar1->SimpleText = "";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Header(TObject *Sender)
{
  Memo1->Text = NMNNTP1->Header->Text;
  Edit2->Text = NMNNTP1->HeaderRecord->PrFromAddress;
  Edit3->Text = NMNNTP1->HeaderRecord->PrSubject;
  Edit4->Text = NMNNTP1->HeaderRecord->PrTimeDate;
  Label5->Caption = "    "+IntToStr(NMNNTP1->CurrentArticle);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1HeaderList(TObject *Sender)
{
  ListBox2->Items->Add("["+IntToStr(NMNNTP1->HeaderRecord->PrArticleId)+"]Subject: "+NMNNTP1->HeaderRecord->PrSubject);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1InvalidArticle(TObject *Sender)
{
ShowMessage("   ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1Posted(TObject *Sender)
{
  StatusBar1->SimpleText = "  ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1PostFailed(TComponent *Sender, WORD Errno,
      AnsiString Errmsg)
{
  ShowMessage("   : "+Errmsg+"   "+IntToStr(Errno));

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMNNTP1GroupSelectRequired(bool &Handled)
{
AnsiString S;
  if (InputQuery("   ", "  : ", S)) {
      NMNNTP1->SetGroup(S);
      Handled = true;
  }
}
//---------------------------------------------------------------------------

