//---------------------------------------------------------------------------
#ifndef DSTP2H
#define DSTP2H
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Classes.hpp>
#include <HTTPApp.hpp>
#include <Db.hpp>
#include <DBTables.hpp>
#include <DBWeb.hpp>
#include <DSProd.hpp>
//---------------------------------------------------------------------------
class TWebModule1 : public TWebModule
{
__published:	// IDE-managed Components
        TDataSetTableProducer *DataSetTableProducer1;
        TTable *Table1;
        TAutoIncField *Table1EventNo;
        TIntegerField *Table1VenueNo;
        TStringField *Table1Event_Name;
        TDateField *Table1Event_Date;
        TTimeField *Table1Event_Time;
        TMemoField *Table1Event_Description;
        TCurrencyField *Table1Ticket_price;
        TGraphicField *Table1Event_Photo;
        TDataSetPageProducer *DataSetPageProducer1;
        TQueryTableProducer *QueryTableProducer1;
        void __fastcall WebModule1initialAction(TObject *Sender,
          TWebRequest *Request, TWebResponse *Response, bool &Handled);
        void __fastcall WebModule1defaultAction(TObject *Sender,
          TWebRequest *Request, TWebResponse *Response, bool &Handled);
        void __fastcall DataSetTableProducer1FormatCell(TObject *Sender,
          int CellRow, int CellColumn, THTMLBgColor &BgColor,
          THTMLAlign &Align, THTMLVAlign &VAlign, AnsiString &CustomAttrs,
          AnsiString &CellData);
        void __fastcall WebModule1fullAction(TObject *Sender,
          TWebRequest *Request, TWebResponse *Response, bool &Handled);
        void __fastcall DataSetPageProducer1HTMLTag(TObject *Sender,
          TTag Tag, const AnsiString TagString, TStrings *TagParams,
          AnsiString &ReplaceText);
        void __fastcall WebModule1PhotoAction(TObject *Sender,
          TWebRequest *Request, TWebResponse *Response, bool &Handled);
private:	// User declarations
public:		// User declarations
	__fastcall TWebModule1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TWebModule1 *WebModule1;
//---------------------------------------------------------------------------
#endif
