// FIRSTASP2IMPL.H : Declaration of the TFirstASP2Impl

#ifndef FirstASP2ImplH
#define FirstASP2ImplH

#include "MyASP2p_TLB.H"
#include <asphlpr.h>

/////////////////////////////////////////////////////////////////////////////
// TFirstASP2Impl     Implements IFirstASP2, default interface of FirstASP2
// ThreadingModel : Apartment
// Dual Interface : TRUE
// Default ProgID : MyASP2p.FirstASP2
// Description    :
/////////////////////////////////////////////////////////////////////////////
class ATL_NO_VTABLE TFirstASP2Impl :
  public CComObjectRootEx<CComSingleThreadModel>,
  public CComCoClass<TFirstASP2Impl, &CLSID_FirstASP2>,
  public IDispatchImpl<IFirstASP2, &IID_IFirstASP2, &LIBID_MyASP2p>,
  public TASPObject
{
public:
  TFirstASP2Impl()
  {
  }

  // Data used when registering Object
  //
  DECLARE_THREADING_MODEL(otApartment);
  DECLARE_PROGID("MyASP2p.FirstASP2");
  DECLARE_DESCRIPTION("");

  // Function invoked to (un)register object
  //
  static HRESULT WINAPI UpdateRegistry(BOOL bRegister)
  {
    TTypedComServerRegistrarT<TFirstASP2Impl>
    regObj(GetObjectCLSID(), GetProgID(), GetDescription());
    return regObj.UpdateRegistry(bRegister);
  }

DECLARE_NOT_AGGREGATABLE(TFirstASP2Impl)

BEGIN_COM_MAP(TFirstASP2Impl)
  COM_INTERFACE_ENTRY(IFirstASP2)
  COM_INTERFACE_ENTRY2(IDispatch, IFirstASP2)
END_COM_MAP()

// IFirstASP2
public:

  STDMETHOD(OnEndPage());
  STDMETHOD(OnStartPage(LPUNKNOWN AScriptingContext));
  STDMETHOD(GetTime(BSTR* Param1));
};

#endif //[IDEHeaderName]
