//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "pop3_dem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
  Label8->Caption = "    : "+ NMPOP31->AttachFilePath;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
AnsiString  S;
  if (SelectDirectory(S, TSelectDirOpts() << sdAllowCreate << sdPerformCreate << sdPrompt, 0)) {
      Label8->Caption = "    : "+ S;
      NMPOP31->AttachFilePath = S;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if (NMPOP31->Connected)
    NMPOP31->Disconnect();
  else {
    NMPOP31->Host = Edit1->Text;
    NMPOP31->UserID = Edit2->Text;
    NMPOP31->Password = Edit3->Text;
    NMPOP31->DeleteOnRead = CheckBox1->Checked;
    NMPOP31->Connect();
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Memo2->Clear();
  NMPOP31->List();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
int M;
  if (NMPOP31->MailCount > 0) {
    M = StrToIntDef( Edit8->Text, -1);
    if (M < 0 || M > NMPOP31->MailCount)
      ShowMessage("   ");
    else {
        NMPOP31->GetMailMessage(M);
        Edit4->Text = NMPOP31->MailMessage->From;
        Edit6->Text = NMPOP31->MailMessage->Subject;
        Edit7->Text = NMPOP31->MailMessage->MessageId;
        Memo3->Lines->Assign(NMPOP31->MailMessage->Head);
        Memo1->Lines->Assign(NMPOP31->MailMessage->Body);
        Memo4->Text = NMPOP31->MailMessage->Attachments->Text;
    }
  }
  else
    ShowMessage("    ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
int M;
  if (NMPOP31->MailCount > 0) {
    M = StrToIntDef( Edit8->Text, -1);
    if (M < 0 || M > NMPOP31->MailCount)
      ShowMessage("   ");
    else {
      NMPOP31->GetSummary(M);
      Edit4->Text = NMPOP31->Summary->From;
      Edit6->Text = NMPOP31->Summary->Subject;
      Edit5->Text = IntToStr(NMPOP31->Summary->Bytes);
      Edit7->Text = NMPOP31->Summary->MessageId;
      Memo1->Lines->Assign(NMPOP31->Summary->Header);
    }
  } else
    ShowMessage("    ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
int M;
  if (NMPOP31->MailCount > 0) {
    M = StrToIntDef( Edit8->Text, -1);
    if (M < 0 || M > NMPOP31->MailCount)
      ShowMessage("   ");
    else
      NMPOP31->DeleteMailMessage(StrToInt(Edit8->Text));
  } else
    ShowMessage("    ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31Connect(TObject *Sender)
{
  if (NMPOP31->MailCount > 0)
    ShowMessage("    : "+IntToStr(NMPOP31->MailCount));
  else
    ShowMessage("   ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31ConnectionFailed(TObject *Sender)
{
  ShowMessage(" ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31ConnectionRequired(bool &Handled)
{
  if (MessageDlg("  .  ?", mtConfirmation, TMsgDlgButtons() << mbOK << mbCancel, 0) == mrOk) {
    Handled = true;
    NMPOP31->Connect();
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31DecodeStart(AnsiString &FileName)
{
AnsiString  S;

  S = FileName;
  if (InputQuery("  ", "  ", S))
    FileName = S;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31Disconnect(TObject *Sender)
{
    ShowMessage(" ...");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31Failure(TObject *Sender)
{
  ShowMessage("  ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31InvalidHost(bool &Handled)
{
AnsiString TmpStr;
  if (InputQuery("    !", "  :", TmpStr)) {
    NMPOP31->Host = TmpStr;
    Handled = true;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31List(int Msg, int Size)
{
  Memo2->Lines->Add(IntToStr(Msg)+" / "+IntToStr(Size));

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31Reset(TObject *Sender)
{
  ShowMessage("    ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMPOP31RetrieveEnd(TObject *Sender)
{
  Memo1->Text = NMPOP31->MailMessage->Body->Text;
  Edit4->Text = NMPOP31->MailMessage->From;
  Edit5->Text = NMPOP31->MailMessage->Subject;

}
//---------------------------------------------------------------------------

