//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "smtp_dem.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
 if (!NMSMTP1->Connected) {
      NMSMTP1->Host = Edit1->Text;
      NMSMTP1->Port = StrToInt(Edit2->Text);
      NMSMTP1->UserID = Edit3->Text;
      NMSMTP1->Connect();
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 if (NMSMTP1->Connected)
    NMSMTP1->Disconnect();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  if (OpenDialog1->Execute())
    ListBox1->Items->Add(OpenDialog1->FileName);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
  ListBox1->Items->Delete(ListBox1->ItemIndex);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
  if (NMSMTP1->Connected) {
    NMSMTP1->ClearParams = CheckBox1->Checked;
    NMSMTP1->SubType = mtPlain;
    switch (RadioGroup1->ItemIndex) {
      case 0: NMSMTP1->EncodeType = uuMime;
      case 1: NMSMTP1->EncodeType = uuCode;
    }
    NMSMTP1->PostMessage->FromAddress = Edit12->Text;
    NMSMTP1->PostMessage->FromName = Edit11->Text;
    NMSMTP1->PostMessage->ToAddress->Text = Edit4->Text;
    NMSMTP1->PostMessage->ToCarbonCopy->Text = Edit5->Text;
    NMSMTP1->PostMessage->ToBlindCarbonCopy->Text = Edit6->Text;
    NMSMTP1->PostMessage->Body->Text = Memo1->Text;
    NMSMTP1->PostMessage->Attachments->Text = ListBox1->Items->Text;
    NMSMTP1->PostMessage->Subject = Edit7->Text;
    NMSMTP1->PostMessage->LocalProgram = "C++Builder 5.0 Example";
    NMSMTP1->PostMessage->Date = DateToStr(Date());
    NMSMTP1->PostMessage->ReplyTo = Edit10->Text;
    NMSMTP1->SendMail();
  } else
    ShowMessage("    SMTP");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
  NMSMTP1->ClearParameters();
  Edit4->Clear();
  Edit5->Clear();
  Edit6->Clear();
  Edit7->Clear();
  Edit10->Clear();
  Memo1->Clear();
  ListBox1->Clear();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
AnsiString TmpStr;
  TmpStr = Edit8->Text;
  if (NMSMTP1->Verify(TmpStr))
    ShowMessage(" "+TmpStr+" ");
  else
    ShowMessage(" "+TmpStr+"  ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
  NMSMTP1->ExpandList(Edit9->Text);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1AttachmentNotFound(AnsiString Filename)
{
  ShowMessage("  "+Filename+"  ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1AuthenticationFailed(bool &Handled)
{
AnsiString  S;
  S = NMSMTP1->UserID;
  if (InputQuery(" ", "  .   : ", S)) {
    NMSMTP1->UserID = S;
    Handled = true;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1Connect(TObject *Sender)
{
  StatusBar1->SimpleText ="";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1ConnectionFailed(TObject *Sender)
{
  ShowMessage(" ");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1ConnectionRequired(bool &Handled)
{
  if (MessageDlg("  . ?", mtConfirmation, TMsgDlgButtons() << mbOK << mbCancel, 0) == mrOk) {
    NMSMTP1->Connect();
    Handled = true;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1Disconnect(TObject *Sender)
{
  if (StatusBar1 != NULL)
    StatusBar1->SimpleText = " ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1EncodeEnd(AnsiString Filename)
{
  StatusBar1->SimpleText = "  "+Filename +" ";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1EncodeStart(AnsiString Filename)
{
  StatusBar1->SimpleText = "  "+Filename;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1Failure(TObject *Sender)
{
  StatusBar1->SimpleText = "";
        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1HostResolved(TComponent *Sender)
{
  StatusBar1->SimpleText = " ";
        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1InvalidHost(bool &Handled)
{
AnsiString  TmpStr;
  if (InputQuery("  !", "  :", TmpStr)) {
    NMSMTP1->Host = TmpStr;
    Handled = true;
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1MailListReturn(AnsiString MailAddress)
{
  Memo2->Lines->Add(MailAddress);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1PacketSent(TObject *Sender)
{
  StatusBar1->SimpleText = " " +IntToStr(NMSMTP1->BytesSent)+"   "+IntToStr(NMSMTP1->BytesTotal);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1RecipientNotFound(AnsiString Recipient)
{
  ShowMessage("  \""+Recipient+"\"  !");

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1SendStart(TObject *Sender)
{
  StatusBar1->SimpleText =" ...";

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1Status(TComponent *Sender,
      AnsiString Status)
{
  if (StatusBar1 != NULL)
    StatusBar1->SimpleText = Status;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::NMSMTP1Success(TObject *Sender)
{
  StatusBar1->SimpleText = " ";

}
//---------------------------------------------------------------------------

